// define variables for the pin numbers
  int pinNr_RedLED = 11;
  int pinNr_GreenLED = 10;
  int pinNr_BlueLED = 9;

const byte numChars = 32;
char receivedChars[numChars]; // an array to store the received data
char tempChars[numChars];    // temporary array for use by strtok() function

// variables to hold the parsed data
int RedValue = 0;
int GreenValue = 0;
int BlueValue = 0;

boolean newData = false;
  
 
void setup() {
// put your setup code here, to run once:

  Serial.begin (9600);

// make the pins output
  pinMode(pinNr_RedLED, OUTPUT);
  pinMode(pinNr_GreenLED, OUTPUT);
  pinMode(pinNr_BlueLED, OUTPUT);
  updateLED();

}

void loop() {
    recvWithStartEndMarkers();
    if (newData == true) { 
        strcpy(tempChars, receivedChars);
            // this temporary copy is necessary to protect the original data
            //   because strtok() replaces the commas with \0
        parseData(); 
        updateLED();
        newData = false;
    }
}




void recvWithStartEndMarkers() {
    static boolean recvInProgress = false;
    static byte ndx = 0;
    char startMarker = '<';
    char endMarker = '>';
    char rc;

    while (Serial.available() > 0 && newData == false) {
        rc = Serial.read();

        if (recvInProgress == true) {
            if (rc != endMarker) {
                receivedChars[ndx] = rc;
                ndx++;
                if (ndx >= numChars) {
                    ndx = numChars - 1;
                }
            }
            else {
                receivedChars[ndx] = '\0'; // terminate the string
                recvInProgress = false;
                ndx = 0;
                newData = true;
            }
        }

        else if (rc == startMarker) {
            recvInProgress = true;
        }
    }
}



void parseData() {
      // split the data into its parts
    char * strtokIndx; // this is used by strtok() as an index

    strtokIndx = strtok(tempChars,",");      // get the first part
    RedValue = atoi(strtokIndx);             // convert this part to an integer
  
    strtokIndx = strtok(NULL, ",");         // this continues where the previous call left off
    GreenValue = atoi(strtokIndx);          // convert this part to an integer

    strtokIndx = strtok(NULL, ",");         // this continues where the previous call left off
    BlueValue = atoi(strtokIndx);           // convert this part to an integer
}



void updateLED() {
// we start with all the LEDs turned off
  analogWrite(pinNr_RedLED, RedValue);
  analogWrite(pinNr_GreenLED, GreenValue);
  analogWrite(pinNr_BlueLED, BlueValue);
} 
 

void clearInputBuffer() {
   while (Serial.available() > 0) {
        Serial.read();
   }
}
